"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.auditMap = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
// https://github.com/ReactiveX/rxjs/issues/1777
exports.auditMap = function (project) { return function (source) {
    return rxjs_1.Observable.create(function (obs) {
        var count = 0;
        return source.pipe(operators_1.tap(function () { return count++; }), operators_1.concatMap(function (e, i) {
            return rxjs_1.concat(rxjs_1.defer(function () { return count === 1 ? project(e, i) : rxjs_1.EMPTY; }), rxjs_1.of(0).pipe(operators_1.tap(function () { return count--; }), operators_1.ignoreElements()));
        })).subscribe(obs);
    });
}; };
//# sourceMappingURL=auditMap.js.map