"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.connect = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var shallowEqual_1 = require("./shallowEqual");
var NONE = Object();
var connectWithoutContext = function (mapInputToProps, options) {
    var arePropsEqual = (options && options.arePropsEqual) || shallowEqual_1.shallowEqual;
    return function (input$) {
        return rxjs_1.concat(rxjs_1.of(NONE), input$)
            .pipe(operators_1.map(function (input) {
            if (input === NONE) {
                return NONE;
            }
            if (input === undefined) {
                return undefined;
            }
            return mapInputToProps(input);
        }), operators_1.pairwise(), operators_1.concatMap(function (_a) {
            var previousProps = _a[0], nextProps = _a[1];
            if (previousProps === NONE) {
                return rxjs_1.of(nextProps);
            }
            if (previousProps === undefined || nextProps === undefined) {
                return rxjs_1.of(nextProps);
            }
            if (arePropsEqual(previousProps, nextProps)) {
                return rxjs_1.EMPTY;
            }
            else {
                return rxjs_1.of(nextProps);
            }
        }));
    };
};
var connectWithContext = function (mapInputToProps, mapInputToContext, options) {
    var connectStateProps = connectWithoutContext(mapInputToProps, options);
    return function (input$) {
        var props$ = connectStateProps(input$);
        var context$ = input$.pipe(operators_1.map(mapInputToContext));
        return props$.pipe(operators_1.withLatestFrom(context$), operators_1.map(function (_a) {
            var props = _a[0], context = _a[1];
            if (props === undefined && context === undefined) {
                return undefined;
            }
            return (__assign(__assign({}, props), context));
        }));
    };
};
function connect(mapInputToProps, mapInputToContextOrOptions, options) {
    if (mapInputToContextOrOptions === undefined || typeof mapInputToContextOrOptions === 'object') {
        return connectWithoutContext(mapInputToProps, mapInputToContextOrOptions);
    }
    else {
        return connectWithContext(mapInputToProps, mapInputToContextOrOptions, options);
    }
}
exports.connect = connect;
//# sourceMappingURL=connect.js.map